#include <iostream>

using namespace std;

int main() {
	long long n, q;
	
	cin >> n >> q;
	int zbir1 = 0, zbir2 = 0;
	long long dan[n], keks[n];
	for(int i = 0; i < n; i++) {
		cin >> dan[i] >> keks[i];
		zbir1 += keks[i];
		zbir2 += dan[i];
	}
	long long x = 0;
	long long konacni[zbir1 + zbir2];
	long long pojela[zbir1 + zbir2];
	konacni[0] = 0;
	pojela[0] = 0;
	for(int i = 1; i < zbir1 + zbir2; i++) {
		if(i == dan[x]) {
			konacni[i] = konacni[i-1] + keks[x];
			x++;
		} else {
			konacni[i] = konacni[i-1];
		}
		
		if(konacni[i] >= 1) {
			konacni[i]--;
			pojela[i] = pojela[i-1] + 1;
		} else {
			pojela[i] = pojela[i-1];
		}
	}
	for(int i = 0; i < q; i++) {
		int upit;
		cin >> upit;
		cout << pojela[upit] << "\n";	
	}
	/*for(int i = 0; i < zbir1 + zbir2; i++) {
		cout << konacni[i] << " ";
	}
	cout << "\n";
	for(int i = 0; i < zbir1 + zbir2; i++) {
		cout << pojela[i] << " ";
	}*/
	
	
	
	
	
	
	return 0;
}